﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Reflection;
using System.IO;
using Telerik.Windows.Documents.FormatProviders;
using Telerik.Windows.Documents;
using Telerik.Windows.Documents.Model;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private static Uri GetResourceUri(string resource)
        {
            AssemblyName assemblyName = new AssemblyName(typeof(MainPage).Assembly.FullName);
            string resourcePath = "/" + assemblyName.Name + ";component/" + resource;
            Uri resourceUri = new Uri(resourcePath, UriKind.Relative);

            return resourceUri;
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            using (Stream stream = Application.GetResourceStream(GetResourceUri("Rad-RichTextBox-for-Silverlight.docx")).Stream)
            {
                IDocumentFormatProvider formatProvider = DocumentFormatProvidersManager.GetProviderByExtension(".docx");
                this.editor.Document = formatProvider.Import(stream);                
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            var inlineBox = this.editor.Document.CaretPosition.GetCurrentInlineBox();

            if (inlineBox.AssociatedInline is Span)
            {
                Span span = (Span)inlineBox.AssociatedInline;
                DocumentPosition start;
                DocumentPosition end;

                HyperlinkRangeStart hyperlinkStart = this.editor.Document.GetContainingAnnotationRanges<HyperlinkRangeStart>(span).LastOrDefault();
                if (hyperlinkStart != null)
                {
                    start = new DocumentPosition(this.editor.Document);
                    start.MoveToInline(hyperlinkStart);
                    end = new DocumentPosition(this.editor.Document);
                    end.MoveToInline(hyperlinkStart.End);
                }
                else
                {
                    start = new DocumentPosition(this.editor.Document.CaretPosition, false);
                    end = new DocumentPosition(this.editor.Document.CaretPosition, false);

                    start = new DocumentPosition(this.editor.Document);
                    start.MoveToInline(inlineBox, 0);
                    end = new DocumentPosition(start);
                    end.MoveToCurrentWordEnd();
                }

                this.editor.Document.Selection.SetSelectionStart(start);
                this.editor.Document.Selection.AddSelectionEnd(end);
            }

            this.editor.ActiveEditorPresenter.FocusCaret();
        }  
    }
}
